///////////////////////////////////////////////////////////////////////////////
//
//  POSTWEB.PRG
//
//  Xb2.NET sample showing how to POST an HTTP request.
//  This program assumes that you are running the sample Xb2.NET webserver
//  (WEBSERVE.EXE) on the same local machine.
//
//  Copyright (c) 2003-2014, Xb2.NET inc.
//  All rights reserved.
//
//  Author:   Boris Borzic
//  Email:    support@xb2.net
//  Web:      http://www.xb2.net
//
///////////////////////////////////////////////////////////////////////////////

* v podstate neviem, o toto rob, resp. by malo robi

#include "xb2net.ch"
#include "common.ch"

#pragma  library ("xb2net.lib")

#xtranslate NTrim(<n>) =>  LTrim(Str(<n>))

//-----------------------------------------------------------------------------
function Main( cMethod )

   DEFAULT cMethod TO "1"

   if AllTrim(cMethod) == "2"
      Return Method2()
   endif

   Return Method1()

//-----------------------------------------------------------------------------
static function Method1()
   Local oHttp, oResponse, oForm, cColor

   cColor := SetColor("r+/n")
   ?? "Method 1: using higher level xbHTTPClient class"
   SetColor(cColor)

   // create an HTTP client instance
   oHttp := xbHTTPClient():new()

   // uncomment this to save request/response to files request.txt & response.txt:
   //oHttp:LogResponse := .t.
* skam odblokova teraz vytvor sbory request.txt a response.txt kde asi ulo o chcel a o dostal zo servera
oHttp:LogResponse := .t.

   // uncomment this to use the Windows WinInet library
   // this is a higher level class that handles cookies, redirects and proxy settings automatically
   // oHttp:Transport := VIA_WININET

   // create the form that we will post to the server
   oForm := xbForm():new()

* tu je zadanie User mena a User hesla
   oForm:SetVar("UID", "KENT")
   oForm:SetVar("PWD", "XRAY")

* tu asi m vykona resp. posla nejak request na webserve, ale nefunguje to, asi preto e login 
* na tej strnke testovacej nie je ?

   ? "executing HTTP request..."

*MsgBox("tu ide na oHttp:Execute, asi by mal vykona nejak prikaz, request posla na webserver ?")

   oResponse := oHttp:Execute("http://localhost/login",,oForm)
*iba som skal testovac prklad kde je TEST a 123 meno heslo ale ni nevrtilo
*   oResponse := oHttp:Execute("http://live.xb2.net/login.htm",,oForm)

   if oResponse == NIL
      MsgBox("Error:" + str(oHttp:ErrorCode) + chr(10) + oHttp:ErrorMessage + chr(10) + oHttp:ErrorSource)
      Return .f.
   endif

   DispResponse( oResponse )

   Return .t.

//-----------------------------------------------------------------------------
static function Method2()
   Local oSock, oRequest, oResponse, oForm, cColor
   Local cHost := "localhost"
   Local nPort := 80
   Local cPath := "/Login"

   cColor := SetColor("r+/n")
   ?? "Method 2: using low level socket and HTTP request/response objects"
   SetColor(cColor)

   // create a socket
   oSock := xbSocket():New(AF_INET, SOCK_STREAM, IPPROTO_IP)

   if oSock:ErrorCode > 0
      MsgBox("Unable to create a socket!" + chr(10) +;
             "Error code: " + NTrim(oSock:ErrorCode) + " (" + oSock:ErrorText(oSock:ErrorCode) + ")" )
      Return .f.
   endif

   // and connect to the host
   if ! oSock:Connect(cHost, nPort)
      MsgBox("Unable to connect to: " + cHost + chr(10) +;
             "Error code: " + NTrim(oSock:ErrorCode) + " (" + oSock:ErrorText(oSock:ErrorCode) + ")" )
      oSock:destroy()
      Return .f.
   endif

   ? "connected to: ", oSock:RemoteName, ", address:", oSock:InetNtoA(oSock:RemoteAddr), ", port:", NTrim(oSock:RemotePort)


   // since we are going to connect to a web server, let's create an xbHTTPRequest
   // and an xbHTTPResponse object for our socket to help us format HTTP requests
   // and parse responses from the web server

   oRequest  := xbHTTPRequest():new( oSock )
   oResponse := xbHTTPResponse():new( oSock )

   // now we need to format the HTTP request

   oRequest:Command := "POST"
   oRequest:KeepAlive(.f.)
   oRequest:Host(cHost + ":" + NTrim(nPort))
   oRequest:Path(cPath)

   // create the form that we will post to the server
   oForm := xbForm():new()
   oForm:SetVar("UID", "KENT")
   oForm:SetVar("PWD", "XRAY")

   // and attach the form to the request
   oRequest:Content := oForm


   // now send the request
   ? "sending HTTP request..."

   if oRequest:send() == SOCKET_ERROR
      MsgBox("An error occurred trying to send request to HTTP server!" + chr(10) +;
             "Error code: " + NTrim(oSock:ErrorCode) + chr(10) +;
             oSock:ErrorText(oSock:ErrorCode) )
      oSock:destroy()
      Return .f.
   endif

   ? "sent: " + LTrim(Str(oSock:BytesSent)) + " bytes"
   ?
   ? "waiting for reply..."

   if ! oResponse:Recv()
      MsgBox("No reply from HTTP server, connection has been dropped!")
      oSock:destroy()
      Return .f.
   endif

   DispResponse( oResponse )

   // DON'T FORGET TO DESTROY THE OBJECT IN ORDER TO RELEASE SYSTEM HANDLES!!
   oSock:destroy()

   Return .t.

//-----------------------------------------------------------------------------
static procedure DispResponse( oResponse )

   ? "received      :", LTrim(Str(oResponse:BytesReceived)), "bytes"
   ? "start line    :", oResponse:StartLine
   ? "content type  :", oResponse:ContentType()
   ? "content length:", oResponse:ContentLength()
   ? "last modified :", oResponse:LastModified()
   ? "cookies       :", oResponse:GetCookie()
   ?
   ? "This is the response content..."
   SetColor("w/b")

   MemoEdit(oResponse:Content, Row()+1, 0, MaxRow(), MaxCol())

   Return


