
///////////////////////////////////////////////////////////////////////////////
//
//  WEBSERVE.PRG
//
//  Xb2.NET sample showing how to create a simple HTTP/HTTPS and SOAP server
//
//  Copyright (c) 2002-2016, Xb2.NET inc.
//  All rights reserved.
//
//  Author:   Boris Borzic
//  Email:    support@xb2.net
//  Web:      http://www.xb2.net
//
///////////////////////////////////////////////////////////////////////////////


#include "xb2net.ch"
#include "common.ch"
#include "xbp.ch"
#include "error.ch"
#include "class.ch"
#include "fileio.ch"
#include "inkey.ch"
#include "thread.ch"
#include "dll.ch"
#include "service.ch"

*qqq 2.11.2018 doplnen z RAUKN !
* doplnen 2.5.2016  kvli problmu s triedenm VLA pri SPIKN databzach z WISKN
* s tu preddefinovan kontanty pre nastavenie DBE
#include "cdxdbe.ch"
#include "dbfdbe.ch"
#include "foxdbe.ch"

#pragma  library ("xb2net.lib")

#define APP_NAME          'Xb2.NET Web Server'
#define APP_DESCRIPTION   'Xb2.NET HTTP Server'
#define IP_ADDR           INADDR_ANY
#define DEF_PORT          '80'              // HTTP server listening port
#define DEF_SPORT         '443'             // HTTPS server listening port
#define LOG_DIR           '.\log_files'
#define ERR_LOG_FILE      LogDir() + '\ERROR.LOG'
#define SOAP_LOG          'SOAPLOG.TXT'
#define CRLF              (Chr(13)+Chr(10))

#xtranslate NTrim(<n>)    =>  LTrim(Str(<n>))
// tests <x> against a set of possible values, <v1> to <vn>, and returns .T. if the value is in the set
#xtranslate IsOneOf(<x>, <v1> [, <vn>]) => (<x> == <v1> [.OR. <x> == <vn>])

STATIC scParamLine        := ""
STATIC slRunningAsService := .f.
STATIC soServer      // HTTP server
STATIC soSServer     // HTTPS server
STATIC soTLog        // HTTP transaction logger

*qqq 24.9.2018 blokujem skam moje DBESYS z RAUKN
/*
//-----------------------------------------------------------------------------
PROCEDURE DbeSys()
   // Create the DBFCDX Database Engine

   if ! DbeLoad("DBFDBE", .T.) .or. ;
      ! DbeLoad("CDXDBE", .T.) .or. ;
      ! DbeBuild("DBFCDX", "DBFDBE", "CDXDBE")

      Alert("Database Engine DBFCDX not created!", {"OK"})
   endif

   DbeSetDefault("DBFCDX")

   Return
*/

*qqq 2.11.2018 toto spraven poda RAUKN ale zablokovan DC_ALERT km nemm prilinkovan express++
****************************
PROCEDURE DbeSys()
****************************
_LoadDbes()

RETURN

****************************************
STATIC FUNCTION _LoadDbes()
****************************************
LOCAL i, aDbeList := DbeList(), cDbeList := ''

*qqq 22.3.2018 skam zmeni z GERMAN na ASCII, lebo problm ak zdieam databzu s VFP
**************************************************************************************
SET COLLATION TO ASCII                // v CDX sa neobjav iadny text, teda ani SWEFIN

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

  IF !('DBFDBE'$aDbeList) .AND. !DbeLoad( "DBFDBE",.T.)
*     DC_WinAlert( "Database-Engine DBFDBE not loaded" )
  ENDIF
  IF !('NTXDBE'$aDbeList) .AND. !DbeLoad( "NTXDBE",.T.)
*     DC_WinAlert( "Database-Engine NTXDBE not loaded"  )
  ENDIF
  IF !('DBFNTX'$aDbeList) .AND. !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
*     DC_WinAlert( "DBFNTX Database-Engine, Could not build engine" )
  ENDIF
  IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
*    DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  ENDIF
  IF !('DBFCDX'$aDbeList) .AND. !DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
*     DC_WinAlert( "DBFCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
*     DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  ENDIF
  IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
*     DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  ENDIF
  IF !('DELDBE'$aDbeList) .AND. !DbeLoad( "DELDBE",.T.)
*     DC_WinAlert( "Database-Engine DELDBE not loaded" )
  ENDIF

DbeSetDefault( "FOXCDX" )        // toto bolo
*DbeSetDefault( "DBFCDX" )        // toto iba som skal, ale bez rozdielu

DbeInfo(COMPONENT_DATA,  FOXDBE_LIFETIME,       20 )    && bielik

RETURN .t.

* vpis helpu pre pouitie, tj. ak parametre sa zadvaj
//-----------------------------------------------------------------------------
PROCEDURE ParamHelp()
   ?
   ? "Parameters:"
   ? "  /IP:n.n.n.n     - IP address to bind to (default is " + var2char(IP_ADDR) + ")"
   ? "  /PORT:nnnn      - HTTP server port number (default is " + DEF_PORT + ")"
   ? "  /SPORT:nnnn     - HTTPS server port number (default is " + DEF_SPORT + ")"
   ? "  /LOG:dir        - log directory drive + folder (default is " + LOG_DIR + ")"
   ? "  /INSTALL        - install app as windows service"
   ? "  /UNINSTALL      - remove from windows services"
   ? "  /RESTORE        - restore previously saved session data"
   ? "  /CPU:n          - Run on CPU <n>"
   ?
   ? "Example:"
   ? "  WEBSERVE /IP:127.0.0.1 /PORT:8082 /SPORT:443 /CPU:3"
   ?
   Return

//-----------------------------------------------------------------------------
PROCEDURE Main()
   Local i, lInstall, oService, cRootDir
   Local cServiceDesc := APP_DESCRIPTION //+ " " + xbSocket():Version
   Local cServiceName := APP_NAME

   for i := 1 to pcount()
      scParamLine += pvalue(i)
   next

   set exact on
   scParamLine := Upper(scParamLine)

*qqq 6.11.2018 pri nastaven ANSI je dobre diakritika pri browseri RKU807 napr.
SET CHARSET TO ANSI
*SET CHARSET TO OEM

* doplnenie spracovania pre konverzie LATIN2
DEFINUJ_LAT_IBM_O()                // peci podfunkcia, kde zadefinovan pole prevodnej tabuky CP852 na ASCII (je v RAUKNW12.PRG)
DEFINUJ_LAT_IBM_U_O()                // peci podfunkcia, kde zadefinovan pole prevodnej tabuky W1250 na ASCII (je v RAUKNW12.PRG)

   // install/uninstall app as a service

* ak parameter INSTALL, tak sa spust ako sluba/service

   if at("/INSTALL", scParamLine) > 0 .or. at("/UNINSTALL", scParamLine) > 0
      SetAppWindow():hide()
      oService := ServiceController()

      if (lInstall := at("/INSTALL", scParamLine) > 0)
         // replace "/INSTALL" parameter with "/SERVICE"
         scParamLine := StrTran(scParamLine, "/INSTALL", "/SERVICE")
      endif

      if oService:addController( ;
         cServiceName, ;                     // service name
         cServiceDesc, ;                     // service description
         AppName(.t.) + " " + scParamLine,;  // service path name + parameters
         nil, ;                              // user account name
         nil, ;                              // user account password
         scParamLine, ;                      // command line params that will be passed to app when it's started as a service
         Logger():new())

         // new controller instance created

         if lInstall
            // install service
            if oService:Install(cServiceName)
               if oService:Start(cServiceName)
                  MsgBox(cServiceName + " installed and started successfully.", cServiceName + " Installer")
               else
                  i := oService:getUpdatedControl(cServiceName):getLastError()
                  MsgBox(cServiceName + " is installed but failed to start!" + CRLF +;
                         "Error "+ NTrim(i) + "; "+ DosErrorMessage(i) + CRLF + CRLF +;;
                         "Please ensure service login account has sufficient access rights.", cServiceName + " Installer")
               endif
            else
               MsgBox(cServiceName + " failed to install!",cServiceName + " Installer")
            endif

         elseif oService:UnInstall( cServiceName )
            MsgBox(cServiceName + " service has been removed successfully!", cServiceName + " Installer")

         endif
      endif

      quit
   endif

* ak je spusten ako SERVICE, tj. sluba
   if At("/SERVICE", scParamLine) > 0
      // running as NT service app
      slRunningAsService := .t.

      // make the app path the default path
      cRootDir := AppName(.t.)
      CurDir( Left(cRootDir, RAt("\",cRootDir)-1) )
      CurDrive( Left(cRootDir,1) )

	* spa sa ako sluba/servis
      oService := ServiceApp()   // ref to this app!
      oService:main := {||StartService()}
      oService:stop := {||Shutdown(.T.)}
      oService:start()

* ak je spusten ako konzolov aplikcia
   else
	* ak /? vype help ako zada parametre
      if "/?" $ scParamLine .or. "/HELP" $ scParamLine
         ? cServiceDesc
         ParamHelp()
         inkey(0)
         quit
      endif

      // make the console window bigger
      SetAppWindow():Configure( NIL, NIL, {0,28}, 34, 80, AppName())

	* spust sa ako konzolov aplikcia
      // running as console app
      StartService()
   endif

   Return

//-----------------------------------------------------------------------------
FUNCTION GetParam( cTag, cString, nStartPos /*pass by ref*/ )
   Local i, cVal

   DEFAULT cString TO scParamLine

   if (i := at(upper(cTag), upper(cString), nStartPos)) == 0
      Return nil
   endif

   // save start pos for next tag
   nStartPos := i + len(cTag)

   cVal := SubStr(cString, i+len(cTag))

   if (i := at("/", cVal)) == 0
      Return cVal
   endif

   Return left(cVal, i-1)

//-----------------------------------------------------------------------------
function Shutdown(lSet)
   static lShutdown := .f.
   if lSet == .t.
      lShutdown := .t.
   endif
   Return lShutdown

//-----------------------------------------------------------------------------
PROCEDURE StopService( nPause )
   Shutdown(.t.)
   ErrorLog("Terminating HTTP server...")

   if soServer != NIL
      soServer:onError := NIL
      soServer:Destroy()  // don't forget to destroy the object in order to release socket handles!
   endif
   if soSServer != NIL
      soSServer:onError := NIL
      soSServer:Destroy()  // don't forget to destroy the object in order to release socket handles!
      MySSLContext(.t.)    // also destroy the SSLContext since we don't need it any longer
   endif

   // save all sessions
   // sessions can later be restored by using the /RESTORE command line parameter
   xbSession():SaveSessions()

   // close the log file
   if soTLog != NIL
      soTLog:Close()
   endif
   inkey(nPause)
   // doing a 'QUIT' while running as a service does not terminate service app properly!
   // Quit
   Return

//-----------------------------------------------------------------------------
STATIC FUNCTION LogDir()
   STATIC cLogDir
   if cLogDir == nil
      if Empty(cLogDir := GetParam("/LOG:"))
         cLogDir := LOG_DIR
      endif
   endif
   Return cLogDir

* funkcia asi pre zistenie potu procesorov
//-----------------------------------------------------------------------------
static function SmpGetCPU() ; Return DllCall("Xpprt1.dll",DLL_CDECL,"_sysGetCPU")
static function SmpSetCPU(n); Return DllCall("Xpprt1.dll",DLL_CDECL,"_sysSetCPU", n)
//-----------------------------------------------------------------------------
static function Bit2Array(n)
   local i, aSet[0]
   for i := 1 TO 32
      if n[i]; AAdd(aSet,i-1); endif
   next
   Return aSet

* funkcia pre spustenie sluby
//-----------------------------------------------------------------------------
PROCEDURE StartService()
   Local i, aThread, nKey, cTitle, bErrBlock, oError, cCPU
   Local nCols := MaxCol() + 1

   SetPos(MaxRow()-2,0)

   SET DEFAULT TO .\DATA  // set the default path for DBF files

   CreateDir( LogDir() )  // make sure log directory path exists

   // set CPU affinity
   if !empty(cCPU := GetParam("/CPU:"))
      if SmpSetCPU( 2 ^ val(cCPU) ) == 0
         ErrorLog("CPU param is invalid: " + cCPU)
      endif
   endif
   ? "Running on CPU(s):", Bit2Array(SmpGetCPU())

   // initialize transaction log
   soTLog := xbTLog():New()
   soTLog:SetDir( LogDir() )       // the directory path where log files will be written
   soTLog:TimePeriod := TLOG_DAILY // create daily log files starting with the first entry that occurs after midnight

   // select fields to be logged
   //soTLog:Fields := EXLOG_DATE+EXLOG_TIME+EXLOG_C_IP+EXLOG_CS_USERNAME+EXLOG_S_SITENAME+EXLOG_S_COMPUTERNAME+;
   //                 EXLOG_S_IP+EXLOG_S_PORT+EXLOG_CS_METHOD+EXLOG_CS_URI_STEM+EXLOG_CS_URI_QUERY+;
   //                 EXLOG_SC_STATUS+EXLOG_SC_WIN32_STATUS+EXLOG_SC_BYTES+EXLOG_CS_BYTES+EXLOG_TIME_TAKEN+;
   //                 EXLOG_CS_VERSION+EXLOG_CS_HOST+EXLOG_CS_USER_AGENT+EXLOG_CS_COOKIE+EXLOG_CS_REFERRER

   // set the default error log file
   xbSocket():ErrorLogFile := ERR_LOG_FILE

   // restore previously saved sessions
   // this can be useful if you are temporarily bringing down the server in order to install a new version
   if "/RESTORE" $ scParamLine
      xbSession():RestoreSessions()
   endif

   // limit the number of sessions maintained by the server
   xbSession():MaxSessions := 500

   // start HTTP server in it's own thread
   if HTTPServer() == NIL
      StopService(5)
      Return
   endif

   // check if the OpenSSL library can be loaded
   //
   // Possible reasons why the OpenSSL library cannot be loaded include:
   // 1. Your Xb2NetKey is invalid or it does not include SSL support
   // 2. The OpenSSL LIB files: SSLEAY32.DLL and LIBEAY32.DLL cannot be found in the system path

   bErrBlock := ErrorBlock( {|x|break(x)})
   BEGIN SEQUENCE
      if xbSSLAvailable()
         // start HTTPS server in it's own thread
         HTTPSServer()
      endif

   RECOVER USING oError
      ErrorLog("ERROR: HTTPS server cannot be started!" + CRLF +;
               oError:Description + CRLF +;
               "Do you have the OpenSSL library installed?", .T.)

   ENDSEQUENCE
   ErrorBlock( bErrBlock )


   // The HTTP and HTTPS servers are now running in their own threads, however we need to keep the
   // main thread going otherwise the app will just reach the RETURN statement below and terminate.
   // The solution is to create a loop that can be controlled through the keyboard and where we can
   // monitor the server periodically


   cTitle  := PadM(APP_NAME + " " + xbSocket():Version,  "Started: " + ;
              left(cMonth(date()),3) +" "+ NTrim(Day(date())) +","+ Str(Year(date())) + " @ " + left(Time(),5) +;
              "   (ESC)=Exit", nCols)

* vpis informcii na obrazovke,
*  ak spusten ako service
   if slRunningAsService
      while ! shutdown()
         // display some status info in case the service is allowed to interact with desktop
         DispOutAt(0,0, cTitle, "gr+/b")
         sleep(100)
      end
* ak spusten ako aplikcia
   else
      while ! shutdown()
         DispOutAt(0,0, cTitle, "gr+/b")			// tu nzov programu
         DispOutAt(1,0, PadR(GetStatus(), nCols), "gr+/b" )	// poet pripojen, hintov, at. 
         DispOutAt(2,0, Space(nCols), "w/n")

         aThread := ThreadInfo(THREADINFO_TOBJ)
         for i := Len(aThread) to 1 step -1
            if aThread[i,1] != NIL .and. aThread[i,1]:Active
               DispOutAt(2, i-1, "*", "g/n")
            endif
         next

* oetrenie na ukonenie cez Escape
         nKey := inkey(1)
         if nKey == K_ESC
            if ConfirmBox(nil, "Terminate " + APP_NAME + "?", "Quit", ;
               XBPMB_OKCANCEL, XBPMB_WARNING+XBPMB_MOVEABLE+XBPMB_APPMODAL, XBPMB_DEFBUTTON2) == XBPMB_RET_OK
               exit
            endif
         endif
      end
   endif

   StopService()
   Return

* tu je vpis stavov, napr koko uvateov sa pripojilo, a pod.
//-----------------------------------------------------------------------------
STATIC FUNCTION GetStatus()
   Local n1 := soServer:ActiveConnections()
   Local n2 := soServer:ConnectCount
   Local n3 := Len(soServer:ThreadPool)

   if soSServer != NIL
      n1 += soSServer:ActiveConnections()
      n2 += soSServer:ConnectCount
      n3 += Len(soSServer:ThreadPool)
   endif

   Return "ActiveConnections:" + Str(n1,4) +;
          "; ThreadPool:" + Str(n3,4) +;
          "; OpenSessions:" + Str(xbSession():ActiveSessions(),5) +;
          "; TotalHits:" + Str(n2,9)

//-----------------------------------------------------------------------------
FUNCTION PadM( cStr1, cStr2, nLen, cFillChar )
   Return Left(cStr1 + PadL(cStr2, nLen - Len(cStr1), cFillChar), nLen)

* funkcia pre spustenie HTTP Serveru ?
//-----------------------------------------------------------------------------
FUNCTION HTTPServer()
   Local cVal, nPort, cColor, nErr, cIP

   if Empty(cIP := GetParam("/IP:"))
      cIP := IP_ADDR
   endif

   if Empty(cVal := GetParam("/PORT:"))
      nPort := Val(DEF_PORT)
   else
      nPort := val(cVal)
   endif

   soServer := xbHTTPServer():new( cIP, nPort )

   if (nErr := soServer:ErrorCode) > 0
      ErrorLog("Unable to start HTTP server!" + CRLF +;
               "Error code: " + NTrim(nErr) + " (" + soServer:ErrorText(nErr) + ")", .T. )

      soServer:destroy()
      soServer := NIL

      if nErr == WSAEADDRINUSE
         cColor := SetColor("r+/n")
         ?
         ? "Port:", nPort , "is already being used by another service."
         ? "Try another port or stop the current service that is using port", nPort
         SetColor(cColor)
         ParamHelp()
      endif

      Return NIL
   endif

   MyHttpServerConfig( soServer )

   // this starts the HTTP server in it's own thread
   soServer:start()

   // NOTE: you can run multiple HTTP servers within the same application!
   // For example, the following will create a second web server that can be
   // reached on port 8088, ie: http://www.mysite.com:8088
   //
   // soServer2 := xbHTTPServer():new( INADDR_ANY, 8088 )
   // soServer2:MaxConnections := 30
   // soServer2:RootDir        := "d:\www\support"
   // soServer2:start()

   ErrorLog("HTTP server started on host: " + var2char(soServer:LocalName) + ", Port: " + NTrim(nPort) + CRLF +;
            "Using ZLib " + xbZVersion())

   Return soServer


* funkcia pre spustenie HTTPS Serveru ?
//-----------------------------------------------------------------------------
FUNCTION HTTPSServer()
   Local cVal, nPort, nErr, cIP

   if MySSLContext() == NIL
      Return NIL
   endif

   if Empty(cIP := GetParam("/IP:"))
      cIP := IP_ADDR
   endif

   if Empty(cVal := GetParam("/SPORT:"))
      nPort := Val(DEF_SPORT)
   else
      nPort := val(cVal)
   endif

   soSServer := xbHTTPServer():new( cIP, nPort, MySSLContext() )

   if (nErr := soSServer:ErrorCode) > 0
      ErrorLog("Unable to start HTTPS server!" + CRLF +;
               "Error code: " + NTrim(nErr) + " (" + soSServer:ErrorText(nErr) + ")", .T.)
      soSServer:destroy()
      soSServer := NIL
      MySSLContext(.t.) // destroy the SSLContext since we can't start the HTTPS server
      Return NIL
   endif

   MyHttpServerConfig( soSServer )

   // this starts the HTTP server in it's own thread
   soSServer:start()

   ErrorLog("HTTPS server started on host: " + var2char(soSServer:LocalName) + ", Port: " + NTrim(nPort) + CRLF +;
            "Using " + var2char(MySSLContext():Version[SSLEAY_VERSION]) + CRLF +;
            "Using ZLib " + xbZVersion())

   Return soSServer

* funkcia pre nastavenie parametrov HTTPS Servera, napr. poet pripojen a pod.
//-----------------------------------------------------------------------------
// small function to set up the config parameters for our HTTP and HTTPS servers
// we save a few lines of code since the config settings are the same for both servers
//
STATIC PROCEDURE MyHttpServerConfig( oServer )

   oServer:SessionCookies  := .f.                   // do not use session cookies (each browser tab will have it's own independent session)
                                                    // turn this on if you want only one session per browser instance
   oServer:SessionTimeout  := 15                    // inactive sessions timeout in 15 minutes.
   oServer:MaxConnections  := 64                    // max # of concurrent client threads (note: one client may spawn more than one concurrent connection)
   oServer:MaxRequestLength:= 200000                // set maximum size of files that may be uploaded by client to 200 MBytes
   oServer:MaxHeaderBytes  := 8192                  // set maximum size of header to 8k bytes (default is 16k bytes)
   oServer:RootDir         := ".\www_root"          // this is the root directory where our html files are located
   oServer:IndexFile       := "index.htm"           // default file sent to client; use array for multiple files, eg: {"index.htm","login.htm"}
   oServer:CacheControl    := "max-age=86400"       // allow client-side caching of static files (.htm, .css, jpg,...). Note: Dynamic requests are never cached!
   oServer:TLog            := soTLog                // log client requests
   oServer:CompressLevel   := 7                     // enable compression (for browsers that support 'deflate' compression)
   oServer:onMaxConnect    := {|o| OnMaxConnect(o)} // this is the response that will be sent when the max # of concurrent connections is reached
   oServer:onNotFound      := {|o| OnNotFound(o)}   // log access errors
   oServer:FilterRequest   := {|o| FilterRequest(o)}// pre-process all requests before they get to the standard HTTP handlers
   oServer:LingerTimeout(60)                        // wait up to 60 seconds for buffered data to be received by client
   oServer:RecvTimeout(5000)                        // close a connection after waiting up to 5 seconds for the client to send a new request.
   oServer:SendTimeout(60000)                       // close a connection after waiting up to 60 seconds for the client to accept data.
                                                    // Note: When downloadimg a large file, the user on the client side may need extra time to confirm file save.
                                                    // This causes a delay in transmission and if the timeout is too short the connection will be closed before the entire file is transmitted.

   // NOTE: You can create your own custom handlers:
   // oServer:onGET          := {|o|MyHTTPHandler(o)}
   // oServer:onPOST         := {|o|MyHTTPHandler(o)}
   // oServer:onSOAP         := {|o|MySOAPHandler(o)}
   // oServer:onWebSocket    := {|o|MyWebSocketHandler(o)}
   //
   // uncomment line below to close database connections when socket connection with client is terminated (not recommended)
   // oServer:atEnd   := {||DbCloseAll()}
   //
   // uncomment to log socket related errors
   // oServer:onError := {|o,n,isSSL| xbErrorLog(o,n,isSSL,ERR_LOG_FILE)}

   Return

//-----------------------------------------------------------------------------
CLASS Logger
   EXPORTED:
   INLINE METHOD Write( cMsg )
      ErrorLog( cMsg )
      Return self
ENDCLASS

//-----------------------------------------------------------------------------
STATIC PROCEDURE OnMaxConnect( oClient )
   xbSaveToFile( "= SERVER BUSY ==========" + CRLF +;
                 "Date: " + DTOS(Date()) + " " + Time() + ", IP: " + xbSocket():InetNtoA(oClient:RemoteAddr) + CRLF, ;
                 ERR_LOG_FILE )
   oClient:SendBusy()
   Return

//-----------------------------------------------------------------------------
STATIC PROCEDURE OnNotFound( oClient )
   Local oResp := oClient:HTTPResponse
   LogAccessError("Bad HTTP request:" + CRLF + oClient:HTTPRequest:AsString())
   oResp:StatusCode := 404
   oResp:Content    := "The requested file is not found!"
   oResp:ContentType("text/plain")
   Return

//-----------------------------------------------------------------------------
STATIC PROCEDURE LogAccessError( cText )
   xbSaveToFile( "= ACCESS ERROR ==========" + CRLF +;
                "Date: " + DTOS(Date()) + " " + Time() + ", IP: " + xbSocket():InetNtoA(ThreadObject():RemoteAddr) + CRLF +;
                 cText + CRLF, ;
                 ERR_LOG_FILE )
   Return

//-----------------------------------------------------------------------------
PROCEDURE ErrorLog( cMsg, lHilite )
   Local cColor := iif(lHilite==.T., SetColor("r+/n"), SetColor("bg/n"))
   ?
   ? cMsg                            // display on screen, and
   SetColor(cColor)
   xbErrorLog(cMsg,,, ERR_LOG_FILE)  // log to file
   Return

//-----------------------------------------------------------------------------
FUNCTION FlashError( cMessage, cURL, nDelay, lSound )
   Local cContent := FlashMessage( cMessage, cURL, nDelay )

   cContent := StrTran(cContent, "#036;"  , "#F60;" , 1,1)
   cContent := StrTran(cContent, ":yellow", ":black", 1,1)

   if lSound == .t.
      cContent := StrTran(cContent, "<!--s-->", "<embed src='error.wav' hidden=true autostart=true loop=false>", 1,1)
   endif

   Return (ThreadObject():HTTPResponse:Content := cContent)

* funkcia, ktor zobraz oznam uvateovi a potom sa presmeruje na druh strnku, 
* toto vytvor okienko, niie je zdroj v HTML
* pozri ukku ako msg parameter premietne do HTML, nahradenm reazca
//-----------------------------------------------------------------------------
// generic function to flash a message to the user, then redirect to another page
FUNCTION FlashMessage( cMessage, cURL, nDelay )
   Static cTemplate
   Local cHtml, oClient := ThreadObject()

   DEFAULT cURL   TO oClient:HTTPRequest:Referrer()   // return to previous page
   DEFAULT nDelay TO 2                                // after a 2 sec delay

   if cTemplate == NIL
      TEXT INTO cTemplate TRIMMED
      <html>
      <head><meta name=viewport content="width=device-width,initial-scale=1"></head>
      <body style='background:#000;margin:0;padding:0;'><!--s-->
        <table width=100% height=70%>
          <tr><td align=center>
          <table width=350 height=200 align=center style='background-color:#036;border:solid #6f0 1px;'>
            <tr><td valign=center>
            <table align=center>
              <tr><td style='font:bold 14px verdana;color:yellow;text-align:center;align:center;'><%msg%></td></tr>
            </table>
            </td></tr>
          </table>
          </td></tr>
        </table>
      </body>
      </html>
      ENDTEXT
   endif

   if empty(cURL)
      // return to previous page
      cURL := '"javascript:window.history.back();"'
      cHtml := StrTran(cTemplate, "<!--s-->", '<script type="text/javascript">setTimeout(function(){window.history.back()},'+NTrim(nDelay*1000)+');</script><!--s-->')
   else
      cHtml := cTemplate
   endif

   oClient:HTTPResponse:Refresh( NTrim(nDelay) + "; URL=" + cURL )
   Return oClient:HTTPResponse:Content := StrTran(cHtml, "<%msg%>", cMessage, 1, 1)

* tu je asi ochrana pred spamom, hackermi...
//-----------------------------------------------------------------------------
FUNCTION FilterRequest( oClient )
   Local cUserAgent, cFileExt
   Local cPath := oClient:HTTPRequest:Path()
   Local cRef  := oClient:HTTPRequest:Referrer()

   if oClient:isWebSocket
      // let the HTTP server process WebSocket upgrade requests automatically
      Return .T.
   endif

   if Empty( cPath )
      cPath := ""
   else
      cPath := Lower(cPath)
   endif

   // ? "FilterReq:", oClient:HTTPRequest:StartLine

   // this is an example of how to block some spam and hacker probes
   // this can be expanded and customized by for example loading data from a config or database file

   if ".php" $ cPath .or. ".cgi" $ cPath .or. "cgi-bin" $ cPath .or. ".asp" $ cPath
      oClient:NoLog := .t. // don't want to record this in the log file
      oClient:close()      // don't bother to respond, just close the connection
      Return .F.

   elseif !empty(cRef)     // limit referrer spam
      cRef := lower(cRef)
      if "best-seo" $ cRef .or. "r-e-f-e-r-e-r" $ cRef
         oClient:NoLog := .t.
         oClient:close()
         Return .F.
      endif
   endif

   // Provide a mobile browsing experience via custom .css file.
   // If a 'mobile' client is requesting a .css file and a mobile version exists, then return the mobile version.
   // Eg: standard file = "style.css", mobile version = "style.m.css"
   //
   // Note: The parent html only needs to refrence the standard file, eg:
   //
   // <html>
   // <head>
   //    <link rel=stylesheet type=text/css href="style.css">
   //    <meta name=viewport content="width=device-width, initial-scale=1, user-scalable=no">
   // </head>
   //
   // <body>
   //    Hello...
   // </body>
   // </html>

   if !empty(cUserAgent := oClient:HTTPRequest:UserAgent()) ;
      .and. "mobile" $ lower(cUserAgent)

      // If a mobile client and the file requested is a style sheet or image and the
      // file exists with an '.m.css', '.m.jpg',...  extension, then modify the request
      // so we send back the mobile version of the file.
      //
      // NOTE: Most browsers will download images hidden inside an HTML block with style
      // attribute "display:none". The result is wasted bandwidth when the images are
      // never rendered. A simple solution is to create a small 1-pixel image file with
      // *.m.jpg, *.m.gif,... extension for the applicable files.

      cFileExt := right(cPath,4)

      if IsOneOf( cFileExt, ".css", ".jpg", ".gif", ".png" )
         cPath := left(cPath,len(cPath)-3) + "m" + cFileExt
         if FExists(oClient:Parent:RootDir + cPath)
            oClient:HTTPRequest:Path(cPath)
         endif
      endif
   endif

   Return .T.


/******************************************************************************

Sample server-side SOAP functions:

** NOTE **
The default 'onSOAP' event handler will execute an Xbase++ function with a
name corresponding to the xbSOAPEnvelope:Action and a prefix of 'SOAP_'
(for non-secure connection) and 'SSOAP_' (for secure connection). The Xbase++
function will receive two parameters, both xbSOAPEnvelope instances. The first
parameter will represent the SOAP request and the second the response (to be
fulfilled by the function).

A secure connection (using HTTPS) can call SOAP functions with either the
'SOAP_' or 'SSOAP' prefix. However, a non-secure connection can only call a
'SOAP_' function.

*******************************************************************************/

//-----------------------------------------------------------------------------
// Input Parameters:
//    none
//
// Returns:
//    DateTime  - server date & time as an xml string type in the form: "YYYYMMDD HH:MM:SS"
//
PROCEDURE SOAP_GetDateTime( oIn, oOut )
   oOUT:SetVar("DateTime", dtos(date()) + " " + time())
   Return

//-----------------------------------------------------------------------------
// Input Parameters:
//    UserName   - the user name as an xml string type
//    Message    - a text message as an xml string type
//
// Returns:
//    Status     - xml boolean value where 1=success and 0=failed
//    StatusText - text description of Status as an xml string
//
PROCEDURE SOAP_SaveMessage( oIn, oOut )
   Local oClient := ThreadObject()  // a reference to the xbHTTPThread object
   Local cString

   if Empty(oIN:GetVar("UserName")) .or. Empty(oIN:GetVar("Message"))
      // one of the required parameters is missing - send back an appropriate fault response.
      oOUT:SetFault("Client", "Client request is missing some parameters")
   else
      cString := "= SOAP REQUEST: " + oIN:Action + CRLF +;
                 "Date: " + DTOS(Date()) + ", Time: " + Time() + ", Client IP: " + oClient:InetNtoA(oClient:RemoteAddr) + CRLF +;
                 "UserName: " + oIN:GetVar("UserName") + CRLF +;
                 "Message:" + CRLF +;
                 oIN:GetVar("Message") + CRLF

      if xbSaveToFile( cString, oClient:Parent:RootDir + SOAP_LOG )
         oOUT:SetVar("Status"    , .T.)
         oOUT:SetVar("StatusText", "SAVED")
      else
         oOUT:SetVar("Status"    , .F.)
         oOUT:SetVar("StatusText", "ERROR: MESSAGE NOT SAVED")
      endif
   endif
   Return

//-----------------------------------------------------------------------------
// Input:
//    A set of payloads to be base64 encoded
//
// Returns:
//    The same payloads but in a base64 encoded format
//
PROCEDURE SOAP_B64Encode_Payload( oIn, oOut )
   Local oClient := ThreadObject()  // a reference to the xbHTTPThread object
   Local i, aPayload

   if Empty(oIN:Payload:List)
      oOUT:SetFault("Client", "No payload attached")
   else
      aPayload := oIN:Payload:List

      for i := 1 to len(aPayload)
         oOUT:SetVar("File" + NTrim(i), aPayload[i,PL_ID])

         if aPayload[i,PL_DATA_T] == PL_DATA_FILE
            xbSaveToFile( xbBase64Encode(MemoRead(aPayload[i,PL_DATA])), aPayload[i,PL_DATA], .F.)
            oOUT:Payload:Add( aPayload[i,PL_DATA], PL_DATA_FILE, "", PL_TYPE_UNKNOWN, aPayload[i,PL_ID] )
         else
            oOUT:Payload:Add( xbBase64Encode(aPayload[i, PL_DATA]), PL_DATA_STRING, "text/plain", PL_TYPE_MIME, aPayload[i,PL_ID] )
         endif
      next

      // send the payload
      oClient:HTTPResponse:Send()
      // erase all temp files once payload is transmitted
      oOUT:Payload:Erase()
   endif

   Return

//-----------------------------------------------------------------------------
// Input Parameters:
//    any, including attachments
//
// Returns:
//    a copy of all input parameters + attachments
//
PROCEDURE SOAP_EchoAll( oIn, oOut )
   oOUT:SetVar(oIN:GetVar())
   oOUT:SetStyle(oIN:MessageStyle)
   oOUT:Payload   := oIN:Payload
   oOUT:Version   := oIN:Version
   oOUT:NameSpace := oIN:NameSpace

   // transmit the result including any payloads
   ThreadObject():HTTPResponse:Send()
   // erase all temp files once payload is transmitted
   oIN:Payload:Erase()
   Return

//-----------------------------------------------------------------------------
// Input Parameters:
//    none
//
// Returns:
//    IP - the remote host IP address in dotted-decimal notation
//
PROCEDURE SOAP_GetMyIP( oIn, oOut )
   oOUT:Version   := oIN:Version
   oOUT:NameSpace := oIN:NameSpace
   oOUT:SetStyle(oIN:MessageStyle)
   oOUT:SetVar("IP", xbSocket():InetNtoA(ThreadObject():RemoteAddr))
   Return


/******************************************************************************

Sample server-side WebSocket functions:

** NOTE **
The default 'onWebSocket' eventhandler will pass execution of a connected
WebSocket to an Xbase++ function with a name corresponding to the HTTP request
path and a prefix of 'WS_' or 'SWS_'. Backslash (\) characters in the path
are replaced with an underscore character (_). The Xbase++ function will receive
one parameter; a reference to the connected xbWebSocket instance. Example:

WebSocket URI:                      Xbase++ function:
--------------------------------    ---------------------------
ws://localhost/echo                 WS_echo(oWSock)
ws://localhost/test/echo            WS_test_echo(oWSock)
wss://localhost/echo                SWS_echo(oWSock)
wss://localhost/test/2015/echo      SWS_test_2015_echo(oWSock)

A secure connection initiated with the 'wss' prefix can call a function with
either the 'WS_' or 'SWS_' prefix. However, a non-secure connection can only
call a 'WS_' function.

*******************************************************************************/

// Echoes back whatever it receives from client
//
PROCEDURE WS_Echo( oSock )
   Local cError, cRecv := ""

   oSock:RecvTimeout(30000)
   oSock:MaxPayloadSize := 1000 // limit amount of data that we will accept from client

   oSock:Send("We are connected... HIGH FIVE!")
   oSock:Send("WebSocket server powered by Xb2.NET")
   if oSock:isSecure()
      oSock:Send("cipher:" + oSock:GetCurrentCipher(.t.))
   endif
   oSock:Send("Type QUIT to exit...")
   oSock:Send()

   while .t.
      cRecv := oSock:recv()

      if !oSock:Connected
         // endpoint has disconnected
         // oSock:StatusCode will contain reason for closing connection
         exit

      elseif cRecv == NIL .or. oSock:OpCode == NIL
         // Recv() timed out - send ping to see if client is still there
         // and wait up to 3 seconds for client to reply.
         if !oSock:Ping("", 3000, @cError)
            ? cError
            exit
         endif

      // if user wants to quit then initiate socket shutdown from server-side
      elseif upper(cRecv) == "QUIT"
         oSock:send("Good bye...")
         oSock:close()
         exit

      // echo back data received from peer
      elseif oSock:send(cRecv) == SOCKET_ERROR
         exit
      endif
   end

   oSock:destroy()
   xbSSLFreeErrorQueue()
   Return

//-----------------------------------------------------------------------------
// stream data to client
//
PROCEDURE WS_Stream( oSock )
   Local i, j, nOpCode, isFinalFrame

   // for this function we need to use a non-blocking socket
   oSock:SetBlockingMode(.f.)
   oSock:MaxPayloadSize := 1000 // limit amount of data that we will accept from client

   oSock:Send("Xb2.NET WebSocket data streaming test")

   i := j := 1

   while .t.
      if i == 1
         oSock:Send("-------------------------")
         oSock:Send("Sending data stream " + NTrim(j))
         // we specify the data type in the first frame only!
         nOpCode      := WS_OP_TEXT  // text frame (UTF-8 encoded)
         isFinalFrame := .F.
      elseif i < 26
         // the WebSocket opcode must be set to WS_OP_CONT for continuation frames
         nOpCode      := WS_OP_CONT  // continuation frame
      else
         ++j
         isFinalFrame := .T.
      endif

      if oSock:Send(" <"+NTrim(i)+"> "+Replicate(chr(i+96),10), nOpCode, isFinalFrame) == SOCKET_ERROR
         exit // disconnected
      endif

      // Although we don't do anything with it here, we should still process data transmitted by peer.
      // For example, peer may send a PING request and the :Recv() method will automatically respond with a PONG.

      if oSock:recv() == NIL .or. !oSock:Connected
         exit // disconnected
      endif

      sleep(40) // pause after each frame

      if ++i > 26
         i := 1
      endif

      // we don't want to keep this going forever, so we exit after 5 iterations
      if j > 5
         oSock:Send("End of test, good bye...")
         oSock:close()  // this will send a socket close message to client
         exit
      endif
   end

   oSock:destroy()
   xbSSLFreeErrorQueue()
   Return

