// ---------------------------
// Xb2.NET sample showing how to use AJAX to perform a calculation on the server
// ---------------------------

PROCEDURE AjaxCalc()
   Static cHtml
   Local cData, oClient := ThreadObject()

   if cHtml == NIL
      TEXT INTO cHtml WRAP chr(10) TRIMMED
      <!doctype html>
      <html>
      <head>
         <meta name=viewport content="width=device-width, initial-scale=1, user-scalable=no">
         <link rel=stylesheet type=text/css href=/style.css>
         <style type=text/css>
            h1 {color:#900;}
            err {color:red;}
            input {color:#222; background-color:#eee; margin:10px 1px; padding:2px; border-radius:5px;}
         </style>

         <script type="text/javascript">
         function Calculate() {
            var xmlHttp = new XMLHttpRequest();
            var val = document.getElementById("data").value;
            var result = document.getElementById("theResult");

            // specify HTTP POST so that parameters can be passed in request body
            xmlHttp.open("POST", location.href, false);

            // send the data as a simple string that can be macro-compiled on the server
            xmlHttp.send(val);

            // update the HTML page with result of calculation from server
            result.innerHTML = xmlHttp.responseText;
         }
         </script>
      </head>

      <body style="padding-left:8px; max-width:750px;"}>
      <h1>AJAX PRG script sample</h1>
      This sample shows how AJAX may be used send a simple string of data to a server in the payload of an
      HTTP POST request. The server calculates the result and sends back the answer in the HTTP response.
      JavaScript is used on the client-side to display the result without refreshing the entire page.

      <form style="margin:25px 4px;">
         <input id="data" value="(1+2) * 3"/> = <span id="theResult"></span>
         <br>
         <input onclick="Calculate();" type="button" value="Calculate"/>
      </form>

      <hr><a href=/viewsource?%prg%><hilite>View Source</hilite></a>
      </body>
      </html>
      ENDTEXT
      cHtml := strtran(cHtml, "%prg%", ThreadObject():Parent:GetRelativePath(__FILEPATH__))
   endif

   if oClient:HttpRequest:Command == "GET"
      // this is the first call, send the entire HTML page
      oClient:HttpResponse:Content := cHtml
   else
      // this is the AJAX request, this time we just send the answer
      cData := oClient:HttpRequest:Content

      // make sure the submitted data is safe to macro compile
      if isValid(cData)
         // macro compile the data and send back the result as a string
         oClient:HttpResponse:Content := "<hilite>" + Var2Char(&(cData)) + "</hilite>"
      else
         oClient:HttpResponse:Content := "<err>BAD DATA</err>"
      endif
   endif
   Return

// ---------------------------
static function isValid( cData )
   Local i, imax := len(cData)

   if empty(cData) .or. imax > 200
      Return .f.
   endif

   for i := 1 to imax
      if ! cData[i] $ " 0123456789()*/+-.,"
         Return .f.
      endif
   next
   Return Type(cData) == "N"

