// ---------------------------
// Xb2.NET sample showing how to use AJAX to fill a listbox on a web page
// ---------------------------

PROCEDURE AjaxListBox()
   Static cHtml

   if cHtml == NIL
      TEXT INTO cHtml WRAP chr(10) TRIMMED
      <!doctype html>
      <html>
      <head>
         <meta name=viewport content="width=device-width, initial-scale=1, user-scalable=no">
         <link rel=stylesheet type=text/css href=/style.css>
         <style type=text/css>
            h1 {color:#900;}
            input, select {color:#222; background-color:#eee; margin:10px; padding:4px; border-radius:5px; vertical-align:top;}
         </style>

         <script type="text/javascript">
         function GetList() {
            var xmlHttp = new XMLHttpRequest();
            var theList = document.getElementById("theList");

            // set up HTTP GET with URL of server-side function
            xmlHttp.open("GET", "GetListBox()", false);

            // send the request to fetch the list box
            xmlHttp.send(null);

            // populate the list box with data returned from server
            theList.innerHTML = xmlHttp.responseText;
         }
         </script>
      </head>

      <body style="padding-left:8px; max-width:750px;"}>
      <h1>Populate a List Box using AJAX</h1>
      This sample shows how AJAX can be used to fill a list box on a web page with data fetched from the
      server. JavaScript is used on the client-side to display the result without refreshing the entire page.

      <form style="margin:20px 0;">
         <input onclick="GetList();" type="button" value="Fetch List"/>
         <select id="theList" size="3" style="width:90px"></select>
      </form>
      <p />
      <hr><a href=/viewsource?%prg%><hilite>View Source</hilite></a>
      </body>
      </html>
      ENDTEXT
      cHtml := strtran(cHtml, "%prg%", ThreadObject():Parent:GetRelativePath(__FILEPATH__))
   endif

   // Return HTML page
   ThreadObject():HttpResponse:Content := cHtml
   Return

// ---------------------------
PROCEDURE GetListBox()
   TEXT INTO ThreadObject():HttpResponse:Content TRIMMED
      <option>Cedar</option>
      <option>Fir</option>
      <option>Hemlock</option>
      <option>Juniper</option>
      <option>Kauri</option>
      <option>Larch</option>
      <option>Pine</option>
      <option>Spruce</option>
      <option>Yew</option>
   ENDTEXT
   Return

