//-------------------------------------------------------------------------
// Sample Xb2.NET dynamic web page that is compiled on-the-fly as needed.
//
// Just place the .PRG file into one of your http server's web folders and
// call the function from a browser like this: http://mysite.com/colors.prg
//
// The PRG file will be compiled into a DLL the first time it's called. The
// DLL is then loaded into memory so subsequent calls will be much faster.
// When changes are made to the PRG source, it's automatically recompiled
// and the new code is loaded into memory.
//-------------------------------------------------------------------------

#pragma library("xb2net.lib")
#include "common.ch"

PROCEDURE Colors()
   Static cHtml, aColor := {"00","33","66","99","CC","FF"}
   Local R,G,B, cTable, cColor

   if cHtml == NIL
      TEXT INTO cHtml TRIMMED
      <!doctype html>
      <html>
      <head>
        <title>Xb2.NET - dynamic PRG</title>
        <meta name=viewport content="width=device-width, initial-scale=1, user-scalable=no">
      </head>
      <body style="color:#111;background:#fff;font-size:90%;font-family:Sans-Serif;">
      <center>
      <h3>Dynamic HTML generated by Xb2.NET <a href=/viewsource?%prg%>auto-compiled PRG script</a></h3>
      <p><table width="80%">
        %table%
      </table></p>
      (script last compiled on: %date%)
      </center>
      </body>
      </html>
      ENDTEXT

      // get the file name and path from the compiler constant '__FILEPATH__'
      // this way we don't need to hard code it in the source
      cHtml := strtran(cHtml, "%prg%" , ThreadObject():Parent:GetRelativePath(__FILEPATH__))
      cHtml := strtran(cHtml, "%date%", __DATE__ + " " + __TIME__)
   endif

   cTable := ""
   for R := 1 to 6
      for G := 1 to 6
         cTable += "<tr>"
         for B := 1 TO 6
            cColor := aColor[R] + aColor[G] + aColor[B]
            cTable += '<td bgcolor="#'+ cColor + '">#' + cColor + '</td>'
         next
         cTable += "</tr>"
      next
   next

   ThreadObject():HTTPResponse:Content := StrTran(cHtml,"%table%",cTable)
   Return

